(* 
 * Copyright (c) 2001 The University of Wroclaw.
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Id: gont.mli,v 1.2 2002/02/16 12:09:08 malekith Exp $
 *
 * Module interface: Gont
 * Description: Top level module for Gont compiler. There are two main entry
 * points here. First one, 'compile' compiles specified source file, the 
 * second 'compile_iface' compiles interface. We also have helper 
 * dump_module function here.
 *)

type compilation_info = {ci_input_file: string;
                         ci_output_file: string;
                         ci_target_prefix: string;
                         ci_module_name: string}

(* Result int is exit code, 0 for success, != 0 for failure. *)

(* Read target configuration from ci_target_prefix, compile ci_input_file
 * that contains implementation of module ci_module_name, put Ksi code in 
 * ci_output_file. *)
val compile : compilation_info -> int

(* Read interface of ci_module_name from ci_input_file, and write compiled
 * interface to ci_output_file. *)
val compile_iface : compilation_info -> int

(* Dump given module on stdout. *)
val dump_module : (* module name *) string -> int
;;
